import pygame
import data
import random

font_color = [255, 220, 180]
box_bg = [60, 20, 0]
class InfoBox(pygame.sprite.DirtySprite):
    font = None
    frame_img = None
    frame_start = None
    frame_mid = None
    frame_end = None
    def __init__(self, position, text):
        pygame.sprite.DirtySprite.__init__(self)
        if InfoBox.font == None:
            InfoBox.font = data.load_font("akbar.ttf", 20)
        if InfoBox.frame_img == None:
            InfoBox.frame_img, frame_rect = data.load_image("box_frame.PNG")
            InfoBox.frame_start = InfoBox.frame_img.subsurface(pygame.Rect(0, 0, 3, 40))
            InfoBox.frame_mid = InfoBox.frame_img.subsurface(pygame.Rect(3, 0, 1, 40))
            InfoBox.frame_end = InfoBox.frame_img.subsurface(pygame.Rect(4, 0, 3, 40))
        self.text_image = InfoBox.font.render(text, True, font_color, box_bg)
        self.text_rect = self.text_image.get_rect()
        
        x = self.text_rect.width + 20
        self.image = pygame.Surface((x, 40))
        self.image.convert()
        self.image.fill([0, 255, 255])
        self.image.set_colorkey([0, 255, 255])
        self.rect = self.image.get_rect()
        self.image.blit(InfoBox.frame_start, (0, 0))
        x_pos = 3
        while x_pos < x - 3:
            self.image.blit(InfoBox.frame_mid, (x_pos, 0))
            x_pos += 1
        
        self.image.blit(InfoBox.frame_end, (x-3, 0))
        self.text_rect.center = self.rect.center
        self.image.blit(self.text_image, self.text_rect)
        self.rect.center = position
        
class HugeInfoBox(pygame.sprite.DirtySprite):
    font = None
    frame_img = None
    frame_start = None
    frame_mid = None
    frame_end = None
    def __init__(self, position, text):
        pygame.sprite.DirtySprite.__init__(self)
        if HugeInfoBox.font == None:
            HugeInfoBox.font = data.load_font("akbar.ttf", 35)
        if HugeInfoBox.frame_img == None:
            HugeInfoBox.frame_img, frame_rect = data.load_image("huge_box_frame.PNG")
            HugeInfoBox.frame_start = HugeInfoBox.frame_img.subsurface(pygame.Rect(0, 0, 3, 70))
            HugeInfoBox.frame_mid = HugeInfoBox.frame_img.subsurface(pygame.Rect(3, 0, 1, 70))
            HugeInfoBox.frame_end = HugeInfoBox.frame_img.subsurface(pygame.Rect(4, 0, 3, 70))
        self.text_image = HugeInfoBox.font.render(text, True, box_bg, [150, 200, 255])
        self.text_rect = self.text_image.get_rect()
        
        x = self.text_rect.width + 20
        self.image = pygame.Surface((x, 70))
        self.image.convert()
        self.image.fill([0, 255, 255])
        self.image.set_colorkey([0, 255, 255])
        self.rect = self.image.get_rect()
        self.image.blit(HugeInfoBox.frame_start, (0, 0))
        x_pos = 3
        while x_pos < x - 3:
            self.image.blit(HugeInfoBox.frame_mid, (x_pos, 0))
            x_pos += 1
        
        self.image.blit(HugeInfoBox.frame_end, (x-3, 0))
        self.text_rect.center = self.rect.center
        self.image.blit(self.text_image, self.text_rect)
        self.rect.center = position
        
class StatBox(pygame.sprite.DirtySprite):
    font = None
    def __init__(self):
        pygame.sprite.DirtySprite.__init__(self)
        if StatBox.font == None:
            StatBox.font = data.load_font("akbar.ttf", 40)
        
        self.background, self.rect = data.load_image("statbox.PNG")
        self.image = self.background.copy()
        
        self.rect.topright = (pygame.display.get_surface().get_width(), 0)
        
        self.playerheight = 0
        
    def update(self, dt, world):
        if world.climb_height != self.playerheight or self.playerheight == 0:
            height_string = "%im" % (world.climb_height)
            text = StatBox.font.render(height_string, True, font_color, box_bg)
            textrect = text.get_rect()
            textrect.center = self.rect.center
            textrect.move_ip(-self.rect.left, -self.rect.top)
            self.image = self.background.copy()
            self.image.blit(text, textrect)
            self.dirty = 1
            self.playerheight = world.climb_height 
        pass