import os
import pygame
from pygame.locals import *
import data

sounds = {}
def play_sound(filename):
    
    fullname = data.filepath(filename)
    if(not sounds.has_key(filename)):
        try:
            sound = pygame.mixer.Sound(fullname)
            sound.set_volume(0.4)
            sounds[filename] = sound         
        except:
            print "Cannot load sound ", fullname
            raise SystemExit
    else:
        sound = sounds[filename]
    try:
        if not pygame.mixer.get_busy(): #Right way to do this?
            sound.play()
    except:
        print "Cannot play sound ", filename
        raise SystemExit
    
def play_music(filename):

    fullname = data.filepath(filename)

    try:
        pygame.mixer.music.load(fullname)
    except:
        print "Cannot load music ", fullname
        raise SystemExit
       
    try:
        pygame.mixer.music.set_volume(0.4)
        pygame.mixer.music.play(-1)
    except:
        print "Cannot load music ", filename
        raise SystemExit
    
def pause_music():
    pygame.mixer.music.pause()
    
def unpause_music():
    pygame.mixer.music.unpause()
    
def stop_music():
    pygame.mixer.music.stop()